<?php
add_action('woocommerce_product_options_general_product_data', 'woocommerce_product_custom_fields');
function woocommerce_product_custom_fields()
{
    global $post;
    $product = wc_get_product($post->ID);
?>
    <div class="product_custom_field">
        <?php woocommerce_wp_checkbox(
            array(
                'id'            => '_mrtarget_purchase_activated',
                'class'         => 'mrtarget_checkbox_admin_panel',
                'wrapper_class' => '',
                'label'         => __('Purchase from Mr Target', 'woocommerce'),
            )
        );
        woocommerce_wp_text_input(
            array(
                'id' => '_mrtarget_redirect_url',
                'label' => __('Purchase from Mr Target URL', 'woocommerce'),
            )
        );
        woocommerce_wp_text_input(
            array(
                'id'            => 'generate_url_button',
                'label'         => __('   ', 'woocommerce'),
            )
        );
        woocommerce_wp_checkbox(
            array(
                'id'            => '_mrtarget_sync_activated',
                'class'         => 'mrtarget_checkbox_admin_panel',
                'wrapper_class' => '',
                'label'         => __('SYNC from Mr Target', 'woocommerce'),
            )
        );
        ?>
    </div>
    <script>
        window.addEventListener('load', function() {
            //var syncCheckbox = document.getElementById('_mrtarget_sync_activated');
            var purchaseCheckbox = document.getElementById('_mrtarget_purchase_activated');

            // syncCheckbox.addEventListener('change', function() {
            //     if (this.checked) {
            //         purchaseCheckbox.checked = false;
            //         document.getElementsByClassName('_mrtarget_redirect_url_field')[0].style.display = 'none';
            //         document.getElementsByClassName('generate_url_button_field')[0].style.display = 'none';
            //     }
            // });

            purchaseCheckbox.addEventListener('change', function() {
                // if (this.checked) {
                //     syncCheckbox.checked = false;
                // }
                if (this.checked) {
                    document.getElementsByClassName('_mrtarget_redirect_url_field')[0].style.display = 'block';
                    document.getElementsByClassName('generate_url_button_field')[0].style.display = 'block';
                } else {
                    document.getElementsByClassName('_mrtarget_redirect_url_field')[0].style.display = 'none';
                    document.getElementsByClassName('generate_url_button_field')[0].style.display = 'none';
                }
            });
            //
            var customButtonField = document.getElementById('generate_url_button');
            var customButtonTrigger = document.createElement('button');
            customButtonTrigger.innerHTML = 'Generate URL';
            customButtonTrigger.setAttribute('class', 'button button-primary');

            customButtonField.parentNode.insertBefore(customButtonTrigger, customButtonField.nextSibling);

            customButtonTrigger.addEventListener('click', function() {
                event.preventDefault();
                var newDiv = document.createElement('div');
                newDiv.classList.add('loader-container');
                var innerDiv = document.createElement('div');
                innerDiv.classList.add('loader');
                newDiv.appendChild(innerDiv);
                customButtonTrigger.parentNode.insertBefore(newDiv, customButtonTrigger.nextSibling);
                customButtonTrigger.style.display = 'none';
                var xhr = new XMLHttpRequest();
                xhr.open('POST', '<?php echo admin_url('admin-ajax.php'); ?>');
                xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                xhr.onload = function() {
                    if (xhr.status === 200) {
                        customButtonTrigger.style.display = 'block';
                        newDiv.remove();
                        var response = xhr.response;
                        if (response.charAt(response.length - 1) === "0") {
                            response = response.slice(0, -1);
                        }
                        document.getElementById('_mrtarget_redirect_url').value = response;
                    } else {
                        customButtonTrigger.style.display = 'block';
                        newDiv.remove();
                        document.getElementById('_mrtarget_redirect_url').value = 'XHR error';
                    }
                };
                data = [{
                    sku: '<?= $product->get_sku() ?>',
                }];
                var formData = new FormData();
                formData.append('action', 'generate_url');
                formData.append('data', JSON.stringify(data));
                xhr.send(formData);
            });
            //
        });
    </script>
    <?php if (get_post_meta($post->ID, '_mrtarget_purchase_activated', true) != 'yes') { ?>
        <style>
            ._mrtarget_redirect_url_field {
                display: none;
            }

            .generate_url_button_field {
                display: none;
            }
        </style>
    <?php } ?>
<?php }

add_action('woocommerce_process_product_meta', 'woocommerce_product_custom_fields_save');
function woocommerce_product_custom_fields_save($post_id)
{
    $mrtarget_purchase_activated = isset($_POST['_mrtarget_purchase_activated']) ? 'yes' : 'no';
    if (!empty($mrtarget_purchase_activated)) {
        $mrtarget_redirect_url = $_POST['_mrtarget_redirect_url'];
        if (!empty($mrtarget_redirect_url)) {
            $response = wp_remote_get($mrtarget_redirect_url);
            if (200 === wp_remote_retrieve_response_code($response)) {
                update_post_meta($post_id, '_mrtarget_redirect_url', esc_attr($mrtarget_redirect_url));
                update_post_meta($post_id, '_mrtarget_purchase_activated', esc_attr($mrtarget_purchase_activated));
            } else {
                //error handler with bad response code?
                update_post_meta($post_id, '_mrtarget_redirect_url', esc_attr($mrtarget_redirect_url));
                update_post_meta($post_id, '_mrtarget_purchase_activated', esc_attr($mrtarget_purchase_activated));
            }
        }
    }
    //
}

function get_affiliate_coupon_client()
{
    return get_option('affiliate_id');
}

add_action('wp_ajax_generate_url', 'generate_url');
add_action('wp_ajax_nopriv_generate_url', 'generate_url');
function generate_url()
{
    $data = isset($_POST['data']) ? json_decode(stripslashes($_POST['data']), true) : array();
    $response = send_data_to_api(MR_TARGET_API_URL, $data);
    $answer = json_decode($response, true);
    if ($answer['status'] == 'success') {
        $url = $answer['url'];
        $coupon = get_affiliate_coupon_client();
        $url = $url . '?affiliate=' . $coupon . '&utm_source=affiliate&utm_medium=ecommerce&utm_campaign=' . $coupon;
        print_r($url);
    } else {
        print_r($answer['status']);
    }
}

function send_data_to_api($url, $data)
{
    $args = array(
        'body'        => json_encode($data),
        'headers'     => array(
            'Content-Type' => 'application/json',
        ),
        'method'      => 'POST',
        'data_format' => 'body',
        'sslverify'   => false,
    );

    $response = wp_remote_post($url, $args);

    if (is_wp_error($response)) {
        $error_message = $response->get_error_message();
        return "Error: $error_message";
    }

    return wp_remote_retrieve_body($response);
}
