<?php
add_filter('woocommerce_locate_template', 'custom_replace_simple_template', 10, 3);

function custom_replace_simple_template($template, $template_name, $template_path)
{
    if ($template_name == 'single-product/add-to-cart/simple.php') {
        $template = MR_TARGET_PLUGIN_DIR . 'templates/woocommerce/single-product/add-to-cart/simple.php';
    }
    if ($template_name == 'single-product/add-to-cart/variation-add-to-cart-button.php') {
        $template = MR_TARGET_PLUGIN_DIR . 'templates/woocommerce/single-product/add-to-cart/variation-add-to-cart-button.php';
    }
    return $template;
}

add_filter('woocommerce_loop_add_to_cart_link', 'custom_replace_add_to_cart_button', 10, 2);

function custom_replace_add_to_cart_button($button, $product)
{
    if (get_post_meta($product->get_id(), '_mrtarget_purchase_activated', true) == 'yes') {
        $button = '<div class="purchase-from-mr-target-button-container"><a href="';
        $button .= get_post_meta($product->get_id(), '_mrtarget_redirect_url', true);
        $button .= '" class="purchase-from-mr-target-button">Purchase from Mr Target</a></div>';
    }
    return $button;
}


/*
function custom_replace_add_to_cart_button($button, $product)
{
    $mrtarget_purchase_activated = get_post_meta($product->get_id(), '_mrtarget_purchase_activated', true);

    if ($mrtarget_purchase_activated == 'yes') {
        $new_url = get_post_meta($product->get_id(), '_mrtarget_redirect_url', true);
        $new_text = 'Purchase from Mr Target';
        $button = '<a href="' . esc_url($new_url) . '" class="button">' . esc_html($new_text) . '</a>';
    }

    return $button;
}
add_filter('woocommerce_loop_add_to_cart_link', 'custom_replace_add_to_cart_button', 10, 2);

function remove_single_product_add_to_cart_button()
{
    global $product;
    $mrtarget_purchase_activated = get_post_meta($product->get_id(), '_mrtarget_purchase_activated', true);

    if ($mrtarget_purchase_activated == 'yes') {
        remove_action('woocommerce_single_product_summary', 'woocommerce_template_single_add_to_cart', 30);
    }
}
add_action('woocommerce_before_single_product', 'remove_single_product_add_to_cart_button');

function custom_replace_single_product_add_to_cart_button()
{
    global $product;
    $mrtarget_purchase_activated = get_post_meta($product->get_id(), '_mrtarget_purchase_activated', true);

    if ($mrtarget_purchase_activated == 'yes') {
        $new_url = get_post_meta($product->get_id(), '_mrtarget_redirect_url', true);
        $new_text = 'Purchase from Mr Target';
        echo '<a href="' . esc_url($new_url) . '" class="single_add_to_cart_button button alt">' . esc_html($new_text) . '</a>';
    }
}
add_action('woocommerce_single_product_summary', 'custom_replace_single_product_add_to_cart_button', 30);

function custom_replace_variation_add_to_cart_button()
{
    global $product;
    $mrtarget_purchase_activated = get_post_meta($product->get_id(), '_mrtarget_purchase_activated', true);

    if ($mrtarget_purchase_activated == 'yes') {
        $new_url = get_post_meta($product->get_id(), '_mrtarget_redirect_url', true);
        $new_text = 'Purchase from Mr Target';
?>
        <script type="text/javascript">
            document.addEventListener('DOMContentLoaded', function() {

                function replaceAddToCartButton() {
                    var buttons = document.querySelectorAll('.variations_form .single_add_to_cart_button');
                    buttons.forEach(function(button) {
                        var newButton = document.createElement('a');
                        newButton.href = "<?php echo esc_url($new_url); ?>";
                        newButton.className = 'single_add_to_cart_button button alt';
                        newButton.textContent = '<?php echo esc_html($new_text); ?>';
                        button.parentNode.replaceChild(newButton, button);
                    });
                }

                var variationForms = document.querySelectorAll('.variations_form');
                variationForms.forEach(function(form) {
                    form.addEventListener('show_variation', replaceAddToCartButton);
                });

                replaceAddToCartButton();
            });
        </script>
<?php
    }
}
add_action('woocommerce_single_product_summary', 'custom_replace_variation_add_to_cart_button', 35);
*/
