<?php

/**
 * Plugin Name: Mr Target Affiliate WP & Woo Plugin
 * Description: Mr Target Affiliate WP & Woo Plugin
 * Version:     1.1
 * Author:      ICIT
 * Text Domain: mrtargettextdomain
 * Plugin URI:  https://mrtargetonline.com
 * Author URI:  https://mrtargetonline.com
 */


if (!defined('ABSPATH')) {
    exit;
}

define('MR_TARGET_MIN_PHP_VERSION', '7.2');
define('MR_TARGET_MIN_WP_VERSION', '3.4');
define('MR_TARGET_API_URL', 'https://mrtargetonline.com/wp-json/mrtarget/v1/sku/');
define('MR_TARGET_API_PRODUCTS_URL', 'https://www.mrtargetonline.com/wp-json/mrtarget/v1/products_list');
define('MR_TARGET_SYNC_URL', 'https://mrtargetonline.com/wp-json/mrtarget/v1/products?sku=');
define('MR_TARGET_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('MR_TARGET_API_AND_CACHE_TIME_IN_SECONDS', 1800);

if (version_compare(PHP_VERSION, MR_TARGET_MIN_PHP_VERSION, '<')) {
    require_once ABSPATH . 'wp-admin/includes/plugin.php';

    deactivate_plugins(plugin_basename(__FILE__), true);
    wp_die('<p>The plugin requires a PHP version of at least ' . MR_TARGET_MIN_PHP_VERSION . '; you have ' . PHP_VERSION . '.</p>', 'Plugin Activation Error', array('response' => 200, 'back_link' => true));
}

register_activation_hook(__FILE__, 'mr_target_client_check_woocommerce_dependency');

function mr_target_client_check_woocommerce_dependency()
{
    if (!class_exists('WooCommerce')) {
        deactivate_plugins(plugin_basename(__FILE__));
        wp_die(
            'This plugin requires WooCommerce to be activated. Please install and activate WooCommerce.',
            'Error',
            array('back_link' => true)
        );
    }
}

// Check for WooCommerce on initialization
add_action('admin_init', 'mr_target_client_check_woocommerce_active');

function mr_target_client_check_woocommerce_active()
{
    if (!class_exists('WooCommerce')) {
        add_action('admin_notices', 'mr_target_client_show_woocommerce_inactive_notice');
    }
}

function mr_target_client_show_woocommerce_inactive_notice()
{
    echo '<div class="error"><p>This plugin requires WooCommerce to be activated. Please install and activate WooCommerce.</p></div>';
}

$plugin_path = trailingslashit(WP_PLUGIN_DIR) . 'woocommerce/woocommerce.php';

if (
    in_array($plugin_path, wp_get_active_and_valid_plugins())
    || in_array($plugin_path, wp_get_active_network_plugins())
) {
    require_once MR_TARGET_PLUGIN_DIR . 'loader.php';
}
